UPDATE `#__extensions` SET enabled=1 WHERE type='plugin' AND element LIKE 'improved_ajax_login';
UPDATE `#__extensions` SET enabled=1 WHERE type='plugin' AND element LIKE 'improved_profile';
UPDATE `#__extensions` SET enabled=0 WHERE type='plugin' AND element LIKE 'profile';

CREATE TABLE IF NOT EXISTS `#__offlajn_forms` (
  `id` int(11) unsigned NOT NULL auto_increment, PRIMARY KEY(`id`),
  `ordering` int(11) NOT NULL,
  `state` tinyint(1) NOT NULL default '1',
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `created_by` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `theme` varchar(255) NOT NULL,
  `props` text NOT NULL,
  `fields` text NOT NULL
);

INSERT IGNORE INTO `#__offlajn_forms` (`id`, `ordering`, `state`, `checked_out`, `checked_out_time`, `created_by`, `title`, `type`, `theme`, `props`, `fields`) VALUES
(1, 0, 1, 0, '0000-00-00 00:00:00', 0, 'Registration Form', 'registration', 'elegant', '{"layout":{"jform[layout_columns]":"2","jform[layout_margin]":"10px","jform[layout_width]":"190px"}}', '{"page":[{"elem":[{"jform[elem_type]":{"value":"header","predefined":"title","readonly":true,"button":"Title","icon":"icon-quote icon-font"},"jform[elem_wide]":{"checked":true},"jform[elem_label]":{"value":"","defaultValue":"MOD_LOGIN_REGISTER","placeholder":"Create an account"},"jform[elem_subtitle]":{"value":"","defaultValue":"COM_USERS_REGISTER_REQUIRED","placeholder":"* Required field"}},{"jform[elem_type]":{"value":"textfield","defaultValue":"text","predefined":"name","readonly":true,"button":"Name","icon":"icon-user"},"jform[elem_required]":{"checked":true,"disabled":false},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-name"},"jform[elem_name]":{"value":"name","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_NAME_LABEL","placeholder":"Name:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_REGISTER_NAME_DESC","placeholder":"Enter your full name"},"jform[elem_pattern]":{"value":".+","placeholder":".+"},"jform[elem_error]":{"value":"","defaultValue":"JLIB_FORM_FIELD_INVALID","placeholder":"Invalid field: "}},{"jform[elem_type]":{"value":"textfield","defaultValue":"text","predefined":"username","readonly":true,"button":"Username","icon":"icon-user"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-username"},"jform[elem_name]":{"value":"username","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_USERNAME_LABEL","placeholder":"Username:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_REGISTER_USERNAME_DESC","placeholder":"Enter your desired username"},"jform[elem_error]":{"value":"","defaultValue":"JLIB_DATABASE_ERROR_VALID_AZ09","placeholder":"Please enter a valid username. No spaces, at least 2 characters and must not contain the following characters:  \\\\ \\" '' % ; ( ) &"},"jform[elem_pattern]":{"value":"^[^\\\\\\\\&%''\\";\\\\(\\\\)]{2,}$","placeholder":"^[^\\\\\\\\&%''\\";\\\\(\\\\)]{2,}$"},"jform[elem_ajax]":"username"},{"jform[elem_type]":{"value":"password1","defaultValue":"password","predefined":"password1","readonly":true,"button":"Password","icon":"icon-lock"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-password1"},"jform[elem_name]":{"value":"password1","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_PASSWORD1_LABEL","placeholder":"Password:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_DESIRED_PASSWORD","placeholder":"Enter your desired password - Enter a minimum of 4 characters"},"jform[elem_error]":{"value":"","defaultValue":"JLIB_FORM_FIELD_INVALID","placeholder":"Invalid field: "}},{"jform[elem_type]":{"value":"password2","defaultValue":"password","predefined":"password2","readonly":true,"button":"Password again","icon":"icon-lock"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-password2"},"jform[elem_name]":{"value":"password2","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_PASSWORD2_LABEL","placeholder":"Confirm Password:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_REGISTER_PASSWORD2_DESC","placeholder":"Confirm your password"},"jform[elem_error]":{"value":"","defaultValue":"COM_USERS_REGISTER_PASSWORD1_MESSAGE","placeholder":"The passwords you entered do not match. Please enter your desired password in the password field and confirm your entry by entering it in the confirm password field."}},{"jform[elem_type]":{"value":"textfield","defaultValue":"text","predefined":"email","readonly":true,"button":"Email","icon":"icon-mail-2 icon-envelope"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-email1"},"jform[elem_name]":{"value":"email1","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_EMAIL1_LABEL","placeholder":"Email Address:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_REGISTER_EMAIL1_DESC","placeholder":"Enter your email address"},"jform[elem_error]":{"value":"","defaultValue":"COM_USERS_INVALID_EMAIL","placeholder":"Invalid email address"},"jform[elem_pattern]":{"value":"^([\\\\w0-9\\\\.\\\\-])+\\\\@(([a-zA-Z0-9\\\\-])+\\\\.)+[a-zA-Z]{2,4}$","placeholder":"^([\\\\w0-9\\\\.\\\\-])+\\\\@(([a-zA-Z0-9\\\\-])+\\\\.)+[a-zA-Z]{2,4}$"},"jform[elem_ajax]":"email"},{"jform[elem_type]":{"value":"textfield","defaultValue":"text","predefined":"email2","readonly":true,"button":"Email again","icon":"icon-mail-2 icon-envelope"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-email2"},"jform[elem_name]":{"value":"email2","prefix":"jform[","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"COM_USERS_REGISTER_EMAIL2_LABEL","placeholder":"Confirm email Address:"},"jform[elem_placeholder]":{"value":"","placeholder":""},"jform[elem_title]":{"value":"","defaultValue":"COM_USERS_REGISTER_EMAIL2_DESC","placeholder":"Confirm your email address"},"jform[elem_error]":{"value":"","defaultValue":"COM_USERS_REGISTER_EMAIL2_MESSAGE","placeholder":"The email addresses you entered do not match. Please enter your email address in the email address field and confirm your entry by entering it in the confirm email field."}},{"jform[elem_type]":{"profile":1,"value":"tos","predefined":"tos","readonly":true,"button":"Terms of services","icon":"icon-checkbox icon-ok-circle"},"jform[elem_required]":{"checked":true,"disabled":true},"jform[elem_checked]":{"checked":false,"disabled":true},"jform[elem_wide]":{"checked":false},"jform[elem_id]":{"value":"ial-tos"},"jform[elem_name]":{"value":"tos","prefix":"jform[improved][","readonly":true},"jform[elem_label]":{"value":"","defaultValue":"PLG_USER_PROFILE_OPTION_AGREE","placeholder":"Agree"},"jform[elem_title]":{"value":"","defaultValue":"PLG_USER_PROFILE_FIELD_TOS_DESC","placeholder":"Agree to terms of service"},"jform[elem_article]":{"value":""},"jform[elem_article_name]":{"value":"","placeholder":"Select article for TOS"}},{"jform[elem_type]":{"value":"button","predefined":"submit","readonly":true,"button":"Submit","icon":"icon-arrow-right"},"jform[elem_wide]":{"checked":false},"jform[elem_label]":{"value":"","defaultValue":"JREGISTER","placeholder":"Register"},"jform[elem_subtitle]":{"value":"","placeholder":""}}]}]}');

CREATE TABLE IF NOT EXISTS `#__offlajn_users` (
  user_id INT(11) NOT NULL, PRIMARY KEY(user_id),
  facebook_id VARCHAR(255) NULL,
  google_id VARCHAR(255) NULL,
  windows_id VARCHAR(255) NULL,
  twitter_id VARCHAR(255) NULL,
  linkedin_id VARCHAR(255) NULL
);

CREATE TABLE IF NOT EXISTS `#__offlajn_oauths` (
  `id` int(11) NOT NULL auto_increment, PRIMARY KEY(`id`),
  `name` varchar(127) NOT NULL,
  `alias` varchar(127) NOT NULL,
  `app_id` varchar(127) default NULL,
  `app_secret` varchar(127) default NULL,
  `published` tinyint(1) NOT NULL default '0',
  `create_app` varchar(255) NOT NULL,
  `auth` varchar(255) NOT NULL,
  `token` varchar(255) NOT NULL,
  `userinfo` varchar(255) NOT NULL
);

INSERT IGNORE INTO `#__offlajn_oauths` (`id`, `name`, `alias`, `create_app`, `auth`, `token`, `userinfo`) VALUES
(1, 'Facebook', 'facebook', 'https://developers.facebook.com/apps', 'https://www.facebook.com/dialog/oauth?scope=email&response_type=code&display=popup', 'https://graph.facebook.com/oauth/access_token', 'https://graph.facebook.com/me?access_token='),
(2, 'Google', 'google', 'https://code.google.com/apis/console/', 'https://accounts.google.com/o/oauth2/auth?scope=https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fuserinfo.email+https%3A%2F%2Fwww.googleapis.com%2Fauth%2Fuserinfo.profile&response_type=code&display=popup', 'https://accounts.google.com/o/oauth2/token', 'https://www.googleapis.com/oauth2/v2/userinfo?access_token='),
(3, 'Twitter', 'twitter', 'https://dev.twitter.com/apps', '', '', ''),
(4, 'Microsoft', 'windows', 'https://manage.dev.live.com/Applications', 'https://login.live.com/oauth20_authorize.srf?scope=wl.emails&response_type=code&display=popup', 'https://login.live.com/oauth20_token.srf', 'https://apis.live.net/v5.0/me?access_token='),
(5, 'LinkedIn', 'linkedin', 'https://www.linkedin.com/secure/developer', 'https://www.linkedin.com/uas/oauth2/authorization?response_type=code&scope=r_basicprofile%20r_emailaddress&state=rdt136sdh5f', 'https://www.linkedin.com/uas/oauth2/accessToken', 'https://api.linkedin.com/v1/people/~:(id,first-name,last-name,email-address)?format=json&oauth2_access_token=');